<?php
/*============================================================================
Payment Status Notification is sent as a background process (Method = POST) 
After the notification is received and the api key verification
succeeds change the status of the order to completed (PAID).
* Author	:  Sow Creative Digital Solutions / Smart Secure Solutions
* Author URI:  https://www.sow-creative.com / https://smartsecure.solutions
=============================================================================*/

error_reporting(E_ALL);
ini_set('display_errors', 1);
include 'wp-load.php'; 

/*=============================================================
Background POST request received here, api key is set in POST
==============================================================*/
if(isset($_POST['key'])){
	global $woocommerce; 
    $kObject = new WC_Custom_Payment_Gateway; 
    $key     = $kObject->get_option('bank_key');
    
    // Verify the key sent with the notification is the same as the api key
    if($_POST['key'] == $key){
        $order_id = $_POST['invoice'];         
        $order = new WC_Order( $order_id );
    	
    	// Update order status in back-end
    	if($_POST['status'] == 'paid'){ 
    	     $order->update_status( 'completed' );
    	     $order->add_order_note( __( 'Payment Success' ) );  	     
    	 }
        elseif($_POST['status'] == 'failed'){ $order->update_status( 'failed' );
        
            $order->add_order_note( __( 'Payment Failed' ) );
        } 
        elseif($_POST['status'] == 'cancel'){ $order->update_status( 'cancelled' );
        
            $order->add_order_note( __( 'Payment Canceled' ) );
        }
        elseif($_POST['status'] == 'pending'){ $order->update_status( 'pending' );
        
            $order->add_order_note( __( 'Payment Pending' ) );
        }
    }        
        
  //update $order status to complete/processing/cancel i.e $_POST['status']   
}

/*====================================================================================
* Redirect to woocommerce thank-you page.
* Gateway redirects user to this page (returnURL), api key is not set in POST
* Modifications on the thank-you page need to be done in the template.
====================================================================================*/
if(isset($_GET['invoice'])){
 global $woocommerce; 
 $order_id = $_GET['invoice'];   
 $status   = $_GET['status'];   
 $message  = $_GET['message']; 
 
 $order     = new WC_Order( $_GET['invoice'] );    	     
 $order_key = get_post_meta( $order_id, '_order_key', true);
 
 // You can send the user to a specific page based on the response status
 if($status == 'paid'){ 
   $thank_url = site_url()."/?page_id=8&order-received=$order_id&key=$order_key";	     
 } 
 else if ($status == 'cancel') {
  $thank_url = site_url()."/?page_id=8&order-received=$order_id&key=$order_key";
 } 
 else {
  // Some default thank you page	
  $thank_url = site_url()."/?page_id=8&order-received=$order_id&key=$order_key";
 } 
 
 wp_redirect( $thank_url );
 exit(); 
}
?>
